#!/usr/bin/perl
#
use GD;
require './fetuin9.pl';

$im = GD::Image->new(1000,1000);
$black=$im->colorAllocate(0,0,0);
$white=$im->colorAllocate(255,255,255);
$red=$im->colorAllocate(255,0,0);
$redwhite=$im->colorAllocate(255,128,128);
$green=$im->colorAllocate(0,128,0);
$greenwhite=$im->colorAllocate(128,255,128);

$im->line(500,0,500,1000,$green);
$im->line(0,500,1000,500,$green);

my $resolution=0.5;

my $outputfilename='kika191122b';
@result=(0,0,0,1);
&flib'MakeData($outputfilename.'.txt',"");

$count=1;
for($i=1;$i<=8;$i++){
	@result=&right(45,@result); #a
	@result=&right(32.5,@result); #for b
	@result=&right(35,@result); # for c
	@result=&right(45,@result); # free
	@result=&right(35,@result); # for c
	@result=&right(32.5,@result); # for b
	@result=&right(45,@result); # for a
	@result=&left(45,@result);# for e
#	@result=&left(22.5,@result);
}

$png = $im->png;
open (WR,'>'.$outputfilename.'.png');
binmode WR;
print WR $png;
close WR;

exit;

sub right(){
($rad,$x1,$y1,$xa,$ya)=@_;
&flib'AddData($outputfilename.'.txt','right('.$rad.','.$x1.','.$y1.','.$xa.','.$ya.','.$r.',"'.$count.'");');

$r=214;
$xc=$x1+$ya*$r*sqrt(1/($ya*$ya+$xa*$xa));
$yc=$y1-$xa*$r*sqrt(1/($ya*$ya+$xa*$xa));

$im->filledArc(500+$x1,500+$y1,4,4,0,360,$white);
my $labelflag=0;
for ($t=0;$t<=$rad;$t=$t+$resolution){
    $x2=$xc+cos($t/360*3.14159*2)*($x1-$xc)+sin($t/360*3.14159*2)*($y1-$yc);
    $y2=$yc+cos($t/360*3.14159*2)*($y1-$yc)+sin($t/360*3.14159*2)*(-$x1+$xc);
	#bibun
    $xv=-sin($t/360*3.14159*2)*($x1-$xc)+cos($t/360*3.14159*2)*($y1-$yc);
    $yv=-sin($t/360*3.14159*2)*($y1-$yc)+cos($t/360*3.14159*2)*(-$x1+$xc);
	$im->filledArc(500+$x2,500+$y2,2,2,0,360,$red);
	if ($t>$rad/2 && $labelflag==0){
		$im->string(gdMediumBoldFont,500+$x2,500+$y2,$count,$redwhite);
		$labelflag=1;
		}
    };
$count++;

return ($x2,$y2,$xv,$yv);
}


sub left(){
($rad,$x1,$y1,$xa,$ya)=@_;
&flib'AddData($outputfilename.'.txt','left('.$rad.','.$x1.','.$y1.','.$xa.','.$ya.','.$r.',"'.$count.'");');

$r=214;
$xc=$x1-$ya*$r*sqrt(1/($ya*$ya+$xa*$xa));
$yc=$y1+$xa*$r*sqrt(1/($ya*$ya+$xa*$xa));

$im->filledArc(500+$x1,500+$y1,4,4,0,360,$white);

my $labelflag=0;
for ($t=0;$t>=-$rad;$t=$t-$resolution){
    $x2=$xc+cos($t/360*3.14159*2)*($x1-$xc)+sin($t/360*3.14159*2)*($y1-$yc);
    $y2=$yc+cos($t/360*3.14159*2)*($y1-$yc)+sin($t/360*3.14159*2)*(-$x1+$xc);
	#bibun
    $xv=-sin($t/360*3.14159*2)*($x1-$xc)+cos($t/360*3.14159*2)*($y1-$yc);
    $yv=-sin($t/360*3.14159*2)*($y1-$yc)+cos($t/360*3.14159*2)*(-$x1+$xc);
	$im->filledArc(500+$x2,500+$y2,2,2,0,360,$green);
	if ($t<-$rad/2 && $labelflag==0){
		$im->string(gdMediumBoldFont,500+$x2,500+$y2,$count,$greenwhite);
		$labelflag=1;
		}
    };
$count++;
return ($x2,$y2,-$xv,-$yv);
}
